tagged 0.4.4
[matthijs/upstream/backupninja.git] / backupninja
index 3b3b16d0b363bb17ad7ea93a875d08a03feecc73..b7d4a149e2e73683745e92f224faf899abd1c71f 100755 (executable)
@@ -27,22 +27,24 @@ function setupcolors() {
        RED="\033[31;01m"
        OFF="\033[0m"
        CYAN="\033[36;01m"
+       COLORS=($BLUE $GREEN $YELLOW $RED $PURPLE)
 }
 
-#function run() {
-#      RUNERROR=0
-#      debug 0 "$@"
-#      returnstring=`$@ 2>&1`
-#      RUNERROR=$?
-#      RUNERRORS=$[RUNERRORS+RUNERROR]
-#      if [ "$RUNERROR" != 0 ]; then
-#              debug 3 "Exitcode $RUNERROR returned when running: $@"
-#              debug 3 "$returnstring"
-#      else
-#              debug 0 "$returnstring"
-#      fi
-#      return $RUNERROR
-#}
+function colorize() {
+       if [ "$usecolors" == "yes" ]; then
+               local typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
+               [ "$typestr" == "Debug" ] && type=0
+               [ "$typestr" == "Info" ] && type=1
+               [ "$typestr" == "Warning" ] && type=2
+               [ "$typestr" == "Error" ] && type=3
+               [ "$typestr" == "Fatal" ] && type=4
+               color=${COLORS[$type]}
+               endcolor=$OFF
+               echo -e "$color$@$endcolor"
+       else
+               echo -e "$@"
+       fi
+}
 
 # We have the following message levels:
 # 0 - debug - blue
@@ -56,38 +58,44 @@ function setupcolors() {
 # used to capture output from handlers
 echo_debug_msg=0
 
-usecolor=yes
+usecolors=yes
 
 function printmsg() {
        [ ${#@} -gt 1 ] || return
-        
-       types=(Debug Info Warning Error Fatal)
+
        type=$1
-       print=$[4-type]
-       typestr=${types[$type]}
-       if [ "$usecolor" == "yes" ]; then
-               colors=($BLUE $GREEN $YELLOW $RED $PURPLE)
-               color=${colors[$type]}
-               endcolor=$OFF
-       fi
-       
        shift
-       
-       if [ "$echo_debug_msg" != "0" -a "$type" -gt "1" ]; then
-               echo -e "$typestr: $@"
+       if [ $type == 100 ]; then
+               typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
+               [ "$typestr" == "Debug" ] && type=0
+               [ "$typestr" == "Info" ] && type=1
+               [ "$typestr" == "Warning" ] && type=2
+               [ "$typestr" == "Error" ] && type=3
+               [ "$typestr" == "Fatal" ] && type=4
+               typestr=""
+       else
+               types=(Debug Info Warning Error Fatal)
+               typestr="${types[$type]}: "
        fi
        
-       if [ "$debug" == 1 ]; then
-               echo -e "${color}$typestr: $@${endcolor}" >&2
+       print=$[4-type]
+       
+       if [ $echo_debug_msg == 1 ]; then
+               echo -e "$typestr$@" >&2
+       elif [ $debug ]; then
+               colorize "$typestr$@" >&2
        fi
        
-       if [ "$print" -lt "$loglevel" ]; then
+       if [ $print -lt $loglevel ]; then
                if [ -w "$logfile" ]; then
-                       echo -e "${color}$typestr: $@${endcolor}" >> $logfile
+                       colorize "$typestr$@" >> $logfile
                fi
        fi
 }
 
+function passthru() {
+       printmsg 100 "$@"
+}
 function debug() {
        printmsg 0 "$@"
 }
@@ -230,6 +238,7 @@ The following options are available:
 -t, --test           Run in test mode, no actions are actually taken.
 -n, --now            Perform actions now, instead of when they
                      might be scheduled.
+    --run FILE       Execute the specified action file and then exit.    
 When using colored output, there are:
 EOF
        debug=1
@@ -240,6 +249,13 @@ EOF
        fatal   "Fatal, halting errors (always shown)"
 }
 
+##
+## this function handles the running of a backup action
+##
+## these globals are modified:
+## fatals, errors, warnings, actions_run, errormsg
+##
+
 function process_action() {
        local file="$1"
        local suffix="$2"
@@ -268,24 +284,50 @@ function process_action() {
                IFS=$' \t\n'
        fi
        
-       echo_debug_msg=1
+       let "actions_run += 1"
+
        # call the handler:
-       ret=`( . $scriptdir/$suffix $file )`
-       retcode="$?"
-       warnings=`echo $ret | grep -e "^Warning: " | wc -l`
-       errors=`echo $ret | grep -e "^Error: \|^Fatal: " | wc -l`
-       if [ $errors != 0 ]; then
+       local bufferfile="/tmp/backupninja.buffer.$$"
+       echo "" > $bufferfile
+       echo_debug_msg=1
+       (
+               . $scriptdir/$suffix $file
+       ) 2>&1 | (
+               while read a; do
+                       echo $a >> $bufferfile
+                       [ $debug ] && colorize "$a"
+               done
+       )
+       retcode=$?
+       # ^^^^^^^^ we have a problem! we can't grab the return code "$?". grrr.
+       echo_debug_msg=0
+
+       _warnings=`cat $bufferfile | grep "^Warning: " | wc -l`
+       _errors=`cat $bufferfile | grep "^Error: " | wc -l`
+       _fatals=`cat $bufferfile | grep "^Fatal: " | wc -l`
+       
+       ret=`grep "\(^Warning: \|^Error: \|^Fatal: \)" $bufferfile`
+       rm $bufferfile
+       if [ $_fatals != 0 ]; then
                msg "*failed* -- $file"
+               errormsg="$errormsg\n== failures from $file ==\n\n$ret\n"
+       elif [ $_errors != 0 ]; then
+               msg "*error* -- $file"
                errormsg="$errormsg\n== errors from $file ==\n\n$ret\n"
-       elif [ $warnings != 0 ]; then
+       elif [ $_warnings != 0 ]; then
                msg "*warning* -- $file"
                errormsg="$errormsg\n== warnings from $file ==\n\n$ret\n"
-       elif [ $retcode == 0 ]; then
-               msg "success -- $file"
        else
-               msg "unknown -- $file"
+               msg "success -- $file"
+#      elif [ $retcode == 0 ]; then
+#              msg "success -- $file"
+#      else
+#              msg "unknown -- $file"
        fi
-       echo_debug_msg=0
+
+       let "fatals += _fatals"
+       let "errors += _errors"
+       let "warnings += _warnings"     
 }
 
 #####################################################
@@ -293,6 +335,7 @@ function process_action() {
 
 setupcolors
 conffile="/etc/backupninja.conf"
+loglevel=3
 
 ## process command line options
 
@@ -312,14 +355,31 @@ while [ $# -ge 1 ]; do
                        # we shift here to avoid processing the file path 
                        shift
                        ;;
+               --run)
+                       debug=1
+                       if [ -f $2 ]; then
+                               singlerun=$2
+                               processnow=1
+                       else
+                               fatal "--run option must be fallowed by a backupninja action file"
+                               usage
+                       fi
+                       shift
+                       ;;
                *)
+                       debug=1
                        fatal "Unknown option $1"
                        usage
+                       exit
                        ;;
        esac
        shift
 done                                                                                                                                                                                                           
 
+#if [ $debug ]; then
+#      usercolors=yes
+#fi
+
 ## Load and confirm basic configuration values
 
 # bootstrap
@@ -345,6 +405,7 @@ getconf MYSQL /usr/bin/mysql
 getconf MYSQLHOTCOPY /usr/bin/mysqlhotcopy
 getconf MYSQLDUMP /usr/bin/mysqldump
 getconf GZIP /bin/gzip
+getconf RSYNC /usr/bin/rsync
 
 [ -d "$configdirectory" ] || fatal "Configuration directory '$configdirectory' not found."
 
@@ -355,15 +416,24 @@ fi
 
 ## Process each configuration file
 
-info "====== starting at "`date`" ======"
-
 # by default, don't make files which are world or group readable.
 umask 077
 
+# these globals are set by process_action()
+fatals=0
 errors=0
+warnings=0
+actions_run=0
+errormsg=""
+
+if [ "$singlerun" ]; then
+       files=$singlerun
+else
+       files=`find $configdirectory -mindepth 1 `
+fi
 
-for file in $configdirectory/*; do
-       [ -f $file ] || continue;
+for file in $files; do
+       [ -f "$file" ] || continue
 
        check_perms $file
        suffix="${file##*.}"
@@ -383,7 +453,9 @@ done
 
 ## mail the messages to the report address
 
-if [ "$reportemail" == "" ]; then doit=0
+if [ $actions_run == 0 ]; then doit=0
+elif [ "$reportemail" == "" ]; then doit=0
+elif [ $fatals != 0 ]; then doit=1
 elif [ $errors != 0 ]; then doit=1
 elif [ "$reportsuccess" == "yes" ]; then doit=1
 elif [ "$reportwarning" == "yes" -a $warnings != 0 ]; then doit=1
@@ -391,15 +463,17 @@ else doit=0
 fi
 
 if [ $doit == 1 ]; then
+       debug "send report to $reportemail"
        hostname=`hostname`
+       [ $warnings == 0 ] || subject="WARNING"
+       [ $errors == 0 ] || subject="ERROR"
+       [ $fatals == 0 ] || subject="FAILED"
+       
        {
                for ((i=0; i < ${#messages[@]} ; i++)); do
                        echo ${messages[$i]}
                done
                echo -e "$errormsg"
-       } | mail $reportemail -s "backupninja: $hostname"
+       } | mail $reportemail -s "backupninja: $hostname $subject"
 fi
 
-info "====== finished at "`date`" ======"
-
-############################################################